<template>
    <div>
        <div v-if="story">
            <div class="row mt-5">
                <div class="col-md-10 offset-md-1 offset-2 col-9">
                    <story-item :story="story" :clickable="false"></story-item>
                </div>
                <div class="col-md-10 offset-md-1 offset-2 col-9 my-4" v-if="showAddAnswer">
                    <div class="pb-4">
                        <answer-form @content-saved="addAnswer" :show-error="status==='ERROR'"></answer-form>
                    </div>
                </div>
                <div class="col-md-2 col-9 offset-2 offset-md-9 mt-2" v-if="!showAddAnswer">
                    <button class="btn btn-block btn-dark btn-sm" v-on:click="updateShowAddAnswer">Add new answer</button>
                </div>
            </div>
            <div v-if="answers">
                <div class="row mt-2">
                    <div class="col-md-10 offset-md-1 offset-2 col-9">
                        <h1 class="text-dark">Answers</h1>

                    </div>
                </div>
                <div class="row mt-2 mb-5">
                    <div v-if="!answers.length" class="col-md-10 offset-md-1 offset-2 col-9 mt-3" >
                        There is no answer for this story;
                    </div>
                    <div class="col-md-10 offset-md-1 offset-2 col-9 mt-3" v-for="answer in answers">
                        <small v-if="updateStatusItem===answer.id" class="text-danger">
                            Could not update the answer. Please try again
                        </small>
                        <answer-item @answer-updated="updateAnswer" @rate-clicked="updateAnswerRate"
                                     :answer="answer"></answer-item>
                    </div>
                </div>
            </div>
        </div>
        <div v-else>
            <div class="row mt-5">
                <div class="col-md-10 offset-md-1 offset-2 col-9">
                 There is error loading story, please try again.
                </div>
            </div>
        </div>

    </div>
</template>

<script>
    import StoryItem from "../components/story/StoryItem";
    import AnswerItem from "../components/answer/AnswerItem";
    import AnswerForm from "../components/answer/AnswerForm";

    export default {
        name: "Story",
        components: {AnswerForm, AnswerItem, StoryItem},
        data() {
            return {
                story: null,
                showAddAnswer: false,
                answers: [],
                status: "SAVED",
                updateStatusItem: -1,
            }

        },
        props: {
            id: {type: String, required: true},
            slug: {type: String, required: true}
        },
        created() {
            this.$http.get('languages/' + this.slug + '/stories/' + this.id)
                .then((response) => {
                    this.story = response.data.data
                    this.answers = response.data.data.answers
                });
        },
        methods: {
            updateAnswerRate(answer, rate) {
                answer.rate = rate.value
            },
            updateAnswer(answer, content) {
                this.$http.put('languages/' + this.slug + '/stories/' + this.id+"/answers/"+answer.id, {content: content}).then(
                    (response) => {
                        answer.content = content
                    }
                ).catch((e) => {
                    this.updateStatusItem= answer.id
                    setTimeout(()=>{
                        this.updateStatusItem= -1
                    },3000);

                });
            },
            addAnswer(content) {

                this.$http.post('languages/' + this.slug + '/stories/' + this.id+"/answers", {content: content}).then(
                    (response) => {
                        this.answers.push(response.data.data)
                        this.showAddAnswer = false;
                    }
                ).catch((e) => {
                    this.status= "ERROR"

                });

            },
            updateShowAddAnswer() {
                let token = localStorage.getItem('token');
                if (token) {
                    this.showAddAnswer = true;
                } else {
                    this.$router.push({
                        name: 'login',
                        params: {nextUrl: 'languages/' + this.slug + '/stories/' + this.id}
                    });

                }
            }
        }

    }
</script>
